Loading...
Searching...
No Matches
BALL::VIEW::STLRenderer Class Reference
Visualisation » Renderer

`#include <BALL/VIEW/RENDERING/RENDERERS/STLRenderer.h>`

Inheritance diagram for BALL::VIEW::STLRenderer:

## Public Member Functions

Constructors and Destructors.
| STLRenderer ()
| Default constructor.
| STLRenderer (const String &name)
virtual | ~STLRenderer ()
| Destructor.
virtual void | clear ()
| Clear method.
Accessors
void | setFileName (const String &name)
String | VRMLVector3 (Vector3 input)
Public Member Functions inherited from BALL::VIEW::Renderer
| Renderer ()
| Renderer (const Renderer &renderer)
virtual | ~Renderer ()
virtual bool | init (Scene &scene)
virtual bool | init (const Stage &stage, float height, float width)
virtual void | setLights (bool reset_all=false)
| Set the light sources according to the stage.
virtual void | updateCamera (const Camera *camera=0)
virtual void | updateMaterialForRepresentation (Representation const *)
virtual void | updateBackgroundColor ()
| Update the background color from the stage.
virtual void | setupEnvironmentMap (const QImage &image)
| Setup an environment map.
virtual void | setupStereo (float eye_separation, float focal_length)
virtual void | useContinuousLoop (bool use_loop)
bool | isContinuous ()
virtual bool | hasFPScounter ()
virtual double | getFPS ()
virtual Vector3 | mapViewportTo3D (Position x, Position y)
virtual Vector2 | map3DToViewport (const Vector3 &vec)
virtual void | pickObjects (Position x1, Position y1, Position x2, Position y2, std::list< GeometricObject * > &objects)
virtual void | getFrustum (float &near_f, float &far_f, float &left_f, float &right_f, float &top_f, float &bottom_f)
virtual bool | renderOneRepresentation (const Representation &representation)
virtual void | bufferRepresentation (const Representation &)
virtual void | removeRepresentation (const Representation &)
virtual const Stage & | getStage () const
virtual void | setStage (const Stage &stage)
bool | hasStage () const
| Test if a Stage was assigned to the Renderer.
virtual void | setSize (float width, float height)
| Set the size of the display.
virtual float | getWidth () const
virtual float | getHeight () const
virtual void | setPreviewMode (bool show_preview)
virtual void | showLightSources (bool show_light_sources)
virtual void | renderRuler ()
virtual void | setStereoMode (StereoMode state)
virtual StereoMode | getStereoMode () const
virtual void | setStereoFrustumConversion (int width_factor, int height_factor)
bool | operator== (const Renderer &) const
virtual void | render_ (const GeometricObject *object)
| Wrapper for the renderering of special GeometricObjects.

## Processor specific methods

Size | width
Size | height
File | outfile_
Vector3 | origin_
Matrix4x4 | rotation_
Index | current_indent_
String | endingName_
virtual bool | init (const Stage &stage)
virtual bool | finish ()
void | renderSphere_ (const Sphere &sphere)
| Render a sphere.
void | renderMesh_ (const Mesh &mesh)
| Render a surface mesh.
void | renderTube_ (const Tube &tube)
| Render a tube.
void | renderTwoColoredTube_ (const TwoColoredTube &tube)
| Render a tube with two colors.
void | renderLine_ (const Line &tube)
| Render a line.
void | renderTwoColoredLine_ (const TwoColoredLine &tube)
| Render a line with two colors.
void | out_ (const String &data)
void | outheader_ (const String &data)
void | outfinish_ (const String &data)
void | header_ (const Vector3 &translation, const ColorRGBA &color, const String &rotation="")
void | footer_ ()

## Additional Inherited Members

Public Types inherited from BALL::VIEW::Renderer
enum | StereoMode { NO_STEREO = 0 , ACTIVE_STEREO , DUAL_VIEW_STEREO , DUAL_VIEW_DIFFERENT_DISPLAY_STEREO , TOP_BOTTOM_STEREO , INTERLACED_STEREO }
virtual void | renderClippingPlane_ (const ClippingPlane &)
virtual void | renderLabel_ (const Label &)
virtual void | renderMultiLine_ (const MultiLine &)
| Render an illuminated line.
virtual void | renderPoint_ (const Point &)
| Render a single point.
virtual void | renderBox_ (const Box &)
| Render a box.
virtual void | renderSimpleBox_ (const SimpleBox &)
| Render a simple box (parallel to the axes).
virtual void | renderDisc_ (const Disc &)
| Render a disc.
virtual void | renderGridVisualisation_ (const GridVisualisation &)
| Render a grid.
virtual void | renderQuadMesh_ (const QuadMesh &)
| Render a quad mesh.
Scene * | scene_
const Stage * | stage_
float | width_
float | height_
bool | show_preview_
float | volume_width_
bool | show_light_sources_
Camera | camera_
Vector3 | camera_offset_
bool | use_continuous_loop_
Size | stereo_frustum_conversion_width_
Size | stereo_frustum_conversion_height_
StereoMode | stereo_

## Detailed Description

STLRenderer class. Representation of all primitives as Meshes in stl ==> extrernal rendering of the same scene

Definition at line 35 of file STLRenderer.h.

## Constructor & Destructor Documentation

## STLRenderer() [1/2]

BALL::VIEW::STLRenderer::STLRenderer | ( |  | ) |

Default constructor.

## STLRenderer() [2/2]

BALL::VIEW::STLRenderer::STLRenderer | ( | const String & | name | ) |

Detailed constructor.

Parameters

  name | The name of the file we will create

Exceptions

  BALL::Exception::FileNotFound |

## ~STLRenderer()

virtual BALL::VIEW::STLRenderer::~STLRenderer | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## clear()

virtual void BALL::VIEW::STLRenderer::clear | ( |  | ) |

virtual

Clear method.

Reimplemented from BALL::VIEW::Renderer.

## finish()

virtual bool BALL::VIEW::STLRenderer::finish | ( |  | ) |

virtual

Finish method. This method writes the ending of the file and closes it.

Reimplemented from BALL::VIEW::Renderer.

## footer_()

void BALL::VIEW::STLRenderer::footer_ | ( |  | ) |

protected

## header_()

void BALL::VIEW::STLRenderer::header_ | ( | const Vector3 & | translation,
|  | const ColorRGBA & | color,
|  | const String & | rotation = "" )

protected

## init()

virtual bool BALL::VIEW::STLRenderer::init | ( | const Stage & | stage | ) |

virtual

Start method. This method creates the file and writes the header.

## out_()

void BALL::VIEW::STLRenderer::out_ | ( | const String & | data | ) |

## outfinish_()

void BALL::VIEW::STLRenderer::outfinish_ | ( | const String & | data | ) |

inline

Definition at line 109 of file STLRenderer.h.

## outheader_()

void BALL::VIEW::STLRenderer::outheader_ | ( | const String & | data | ) |

inline

Definition at line 106 of file STLRenderer.h.

## renderLine_()

void BALL::VIEW::STLRenderer::renderLine_ | ( | const Line & |  | ) |

virtual

Render a line.

Reimplemented from BALL::VIEW::Renderer.

## renderMesh_()

void BALL::VIEW::STLRenderer::renderMesh_ | ( | const Mesh & |  | ) |

virtual

Render a surface mesh.

Reimplemented from BALL::VIEW::Renderer.

## renderSphere_()

void BALL::VIEW::STLRenderer::renderSphere_ | ( | const Sphere & |  | ) |

virtual

Render a sphere.

Reimplemented from BALL::VIEW::Renderer.

## renderTube_()

void BALL::VIEW::STLRenderer::renderTube_ | ( | const Tube & |  | ) |

virtual

Render a tube.

Reimplemented from BALL::VIEW::Renderer.

## renderTwoColoredLine_()

void BALL::VIEW::STLRenderer::renderTwoColoredLine_ | ( | const TwoColoredLine & |  | ) |

virtual

Render a line with two colors.

Reimplemented from BALL::VIEW::Renderer.

## renderTwoColoredTube_()

void BALL::VIEW::STLRenderer::renderTwoColoredTube_ | ( | const TwoColoredTube & |  | ) |

virtual

Render a tube with two colors.

Reimplemented from BALL::VIEW::Renderer.

## setFileName()

void BALL::VIEW::STLRenderer::setFileName | ( | const String & | name | ) |

Sets the name of the file we will create.

Parameters

  name | The file name

Exceptions

  BALL::Exception::FileNotFound |

## VRMLVector3()

String BALL::VIEW::STLRenderer::VRMLVector3 | ( | Vector3 | input | ) |

Converts a Vector3 into a String in VRML format as stl works in the same perspektive.

## Member Data Documentation

## current_indent_

Index BALL::VIEW::STLRenderer::current_indent_

protected

Definition at line 125 of file STLRenderer.h.

## endingName_

String BALL::VIEW::STLRenderer::endingName_

protected

Definition at line 126 of file STLRenderer.h.

## height

Size BALL::VIEW::STLRenderer::height

Definition at line 112 of file STLRenderer.h.

## origin_

Vector3 BALL::VIEW::STLRenderer::origin_

protected

Definition at line 123 of file STLRenderer.h.

## outfile_

File BALL::VIEW::STLRenderer::outfile_

protected

Definition at line 121 of file STLRenderer.h.

## rotation_

Matrix4x4 BALL::VIEW::STLRenderer::rotation_

protected

Definition at line 124 of file STLRenderer.h.

## width

Size BALL::VIEW::STLRenderer::width

Definition at line 112 of file STLRenderer.h.